<template>
  <v-card :loading="loading" elevation="3">
    <v-card-title v-if="$slots.title || $slots.icon" :class="{'bugsCardTitle--full': $slots.title && $slots.icon}"
                  class="bugsCardTitle">
      <div v-if="$slots.icon" class="bugsCardTitleIcon">
        <slot name="icon"/>
      </div>
      <div v-if="$slots.title" class="bugsCardTitleText">
        <slot name="title"/>
      </div>
    </v-card-title>
    <v-card-text>
      <template v-if="$slots.text">
        <slot name="text"/>
        <br><br>
      </template>
      <v-expansion-panels v-if="bugs.length" focusable>
        <bug v-for="bug in bugs" :key="bug.type" :bug="bug" :loading="loading" @loading="loading=$event"/>
      </v-expansion-panels>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { BugArray } from '~/types';
import Bug from '~/components/Bug.vue';

export default Vue.extend({
  name: 'BugsCard',
  components: { Bug },
  props: {
    bugs: {
      type: Array,
      required: true,
    } as PropOptions<BugArray[]>,
  },
  data() {
    return {
      loading: false,
    };
  },
});
</script>

<style lang="scss" scoped>
.bugsCardTitle {
  word-break: normal;

  &--full {
    display: grid !important;
    justify-content: space-between;
    align-items: center;
    grid-template-columns: 24px calc(100% - 30px);
    line-height: 100%;
  }
}
</style>
